% Compute the CES_T systemic risk measure and its percentage version
% CES_T_pct  for some particular assets at all dates in the sample!
%--------------------------------------------------------------------------
%
% Denisa Banulescu and Elena Dumitrescu
% LEO, University of Orl?ans
% March 2012
%-------------------------------------


clear all;
clc;

load data_set;

%compute weights for the period 2007/01/03-2010/12/31
%{

sum_mk_cap=sum(mk_cap(:,2:end),2);

weights=NaN*ones(size(mk_cap,1),74);
for i=1:size(mk_cap,1);
  weights(i,:)=(mk_cap(i,2:end)/sum_mk_cap(i))*100;  
end;

% verif sum(weights,2)

weights=[mk_cap(:,1) weights ];
%}

MES_T=NaN*ones(1008,1);                             % initialize the vector of  MES_T

%a_i=1; %the asset
a_i=4; %the asset
%a_i=9; %the asset
%a_i=57; %the asset

for j=1:1008;
    
    waitbar(j/ 1008);

    date=mk_cap(j,1);
    
    [return_Mk_T, returns_T, date_T]=returnMk(returnsL,weights,date); %compute the returns up to date T

    index=return_Mk_T;                                     % Returns of the market (system)

    asset=returns_T(:,a_i);                                  % Returns of the asset

    alpha = 0.05;                                                  % risk level of our VaR

    addpath('/Users/eidumitrescu/Dropbox/RMC/MES');
    res=call_fct(index,asset,alpha);% Compute the systemic risk measures
    MES_T(j)=res.MES(end);          % Keep MES for the asset at date T

    rmpath('/Users/eidumitrescu/Dropbox/RMC/MES');

end


CES_T=weights(:,a_i+1).* MES_T;                % Calculate the CES_T systemic risk mesure for all dates T 2007-2010

%CES_T_pct=CES_T./sum(CES_T);        % Percentage version of the CES_T systemic risk measure

%plot(CES_T)