% Compute the 6-months cummulated OOS CES_T systemic risk measure and its percentage version CES_T_pct
%--------------------------------------------------------------------------
% Note: change 'date' for each oos period considered
%--------------------------------------------------------------------------
%
% Denisa Banulescu and Elena Dumitrescu
% LEO, University of Orl?ans
% March 2012
%-------------------------------------




clear all;
clc;

load data_set;

%{
returnsL=[returns(:,1) log(ones(size(returns,1),size(returns,2)-1)+returns(:,2:end))];
%}

date=20080829;                                                              % systemic risk measure at time 
%date=20100630;                                                              % systemic risk measure at time 

TTd=find(returnsL(:,1)==date);                                              % number of observations up to date 'TT'
h=123;                                                                      %forecast horizon (6 months) in daily

TT=TTd-123;                                                                 % Last in-sample period!!
date_ins=returnsL(TT,1);                                                    % date for the last in-sample observation %!!!!! ONLY  in sample data!!!


[return_Mk_T, returns_T, date_T]=returnMk(returnsL,weights,date_ins);       %compute the returns up to date T-h



MES_oos=NaN*ones(size(returns_T,2),1);                                      % initialize the vector of  MES_oos ( cummulated out-of sample)

C=MES_oos;

S=200000;                                                                   % number of oos paths

addpath('/Users/eidumitrescu/Dropbox/RMC/MES');
    
for i=1:size(returns_T,2);

waitbar(i/ size(returns_T,2));

    index=return_Mk_T;                                                      % Returns of the market (system)

    asset=returns_T(:,i);                                                   % Returns of the asset
    
    res= forecast2(index,asset, h,S);                                     % Compute cummulated oos MES
    
    MES_oos(i)=res.MES_oos;                                                 % Keep MES for the i-th asset
    
    C(i)=res.C;
    
end;

rmpath('/Users/eidumitrescu/Dropbox/RMC/MES');

T=find(weights(:,1)==date_ins);                                             % find the row correponding to the selected in-sample date 

wi_T=weights(T,2:end);                                                      % keep the weights at that specific

CES_oos=wi_T'.* MES_oos;                                                    % Calculate the CES_T systemic risk mesure

CES_oos_pct=CES_oos./sum(CES_oos);                                          % Percentage version of the CES_T systemic risk measure

save res20100630

