% Compute the CES_T systemic risk measure and its percentage version
% CES_T_pct (In-Sample)
%--------------------------------------------------------------------------
%
% Denisa Banulescu and Elena Dumitrescu
% LEO, University of Orl?ans
% March 2012
%-------------------------------------



load data_set;

%compute weights for the period 2007/01/03-2010/12/31
%{

sum_mk_cap=sum(mk_cap(:,2:end),2);

weights=NaN*ones(size(mk_cap,1),74);
for i=1:size(mk_cap,1);
  weights(i,:)=(mk_cap(i,2:end)/sum_mk_cap(i));  
end;

weights=[mk_cap(:,1) weights ];

% verif sum(weights,2)

%}

date=20080829;                      % systemic risk measure at time 

[return_Mk_T, returns_T, date_T]=returnMk(returnsL,weights,date); %compute the returns up to date T

TT=find(returnsL(:,1)==date); 

MES_TT=NaN*ones(TT,size(returns_T,2));% initialize the vector of  MES_T

for i=1:size(returns_T,2);
waitbar(i/ size(returns_T,2));

    index=return_Mk_T;              % Returns of the market (system)

    asset=returns_T(:,i);           % Returns of the asset

    alpha = 0.05;                   % risk level of our VaR

    addpath('/Users/eidumitrescu/Dropbox/RMC/MES');
    res=call_fct(index,asset,alpha);% Compute the systemic risk measures
    MES_TT(:,i)=res.MES;          % Keep MES for the i-th asset

rmpath('/Users/eidumitrescu/Dropbox/RMC/MES');

end;

T=find(weights(:,1)==date);         % find the row correponding to the selected date
wi_T=weights(T,2:end);             % keep the weights at that specific

MES_T=MES_TT(end,:);

CES_T=wi_T'.* MES_T';                % Calculate the CES_T systemic risk mesure

CES_T_pct=CES_T*100./sum(CES_T);        % Percentage version of the CES_T systemic risk measure

%save res20080829c2